/* Minimal screen saver example. */ 
#include <add-ons/screen_saver/ScreenSaver.h> 
#include <interface/StringView.h> 
#include <BeBuild.h>
#include <unistd.h>
#include <stdlib.h>
#include <math.h>

extern "C" {
	_EXPORT	BScreenSaver *instantiate_screen_saver( BMessage *msg, image_id id ); 
}

class MinimalSaver : public BScreenSaver 
{ 
	bool prev;
	float yx, yy;

	public: 
		MinimalSaver( BMessage *archive, image_id image ); 
		virtual ~MinimalSaver( void ); 
		virtual void StartConfig( BView *view ); 
		virtual status_t StartSaver( BView *view, bool preview ); 
		virtual void Draw( BView *view, int32 frame ); 
}; 

BScreenSaver *instantiate_screen_saver( BMessage *msg, image_id id ) 
{ 
	return new MinimalSaver( msg, id ); 
} 

MinimalSaver::MinimalSaver( BMessage *archive, image_id image ) 
    : BScreenSaver( archive, image ) 
{ 
    /* Nothing else to do here... */ 
} 

MinimalSaver::~MinimalSaver( void ) 
{ 
    /* Nothing else to do here... */ 
} 

void MinimalSaver::StartConfig( BView *view ) 
{ 
    view->AddChild( new BStringView( BRect( 10, 10, 200, 35 ), 
                                     B_EMPTY_STRING, 
                                     "Holiday Saver" ) ); 
} 

status_t MinimalSaver::StartSaver( BView *view, bool preview ) 
{ 

	prev = preview;
	SetTickSize(0);

    return B_OK; 
} 

void MinimalSaver::Draw( BView *v, int32 i ) 
{ 
    if( i == 0 ) { 
        /* Fill the screen with black on the first frame: */ 
        v->SetHighColor( 0, 0, 0 ); 
        v->FillRect( v->Bounds(), B_SOLID_LOW ); 
	}
	BRect r = v->Bounds();
	
	v->MovePenTo(50.0,50.0);

	if (prev) {
		v->SetPenSize(2.0);		
	}else {
		v->SetPenSize(4.0);		
	}
	
	float w = r.Width();
	float h = r.Height();
	
	BPoint x(0.0,0.0), y(w,h);

	unsigned char red=0, green=0, blue=0, alpha=0;
	float pi2 = 2.0* PI;
	float cred, cgreen, cblue;
	srand(clock());
	red=((double)rand()/RAND_MAX)*255; 
	green=((double)rand()/RAND_MAX)*255;
	blue=((double)rand()/RAND_MAX)*255;
		
	//red ++;
	//green --;
	//blue += (255-red);	
	// scale colors to 2pi
	cred = pi2/255.0 * red;
	cgreen = pi2/255.0 * green;
	cblue = pi2/255.0 * blue;
	// screen scale factors 			
	
	if (i%200 == 0) {
		yx = (double(rand())/RAND_MAX)*w/1.3 + w/8;
		yy = (double(rand())/RAND_MAX)*h/1.3 + h/8;
	}

	x = BPoint(sin(cgreen)*sin(cred)*sin(cblue)*w/2+yx,
	  		   sin(cgreen)*cos(cred)*cos(cblue)*h/2+yy);
	y = BPoint(yx, yy);
//		y = BPoint(sin(cgreen)*cos(cblue)*sin(cred)*w/2+w/2.0,
//			 	   sin(cgreen)*sin(cblue)*sin(cred)*h/2+h/2.0);
	v->SetHighColor(red,green,blue,alpha);
	v->StrokeLine(x,y);


	if (i%10000==0) {
		v->SetHighColor(0,0,0);
		v->FillRect(v->Bounds());
		}
}